"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var _this = this;
var child_process_1 = require("child_process");
var manifest_creation_1 = require("../manifest-creation");
// use glitch env to get correct domain welcome message
// https://glitch.com/help/project/
var domain = process.env.PROJECT_DOMAIN || "http://localhost:" + (process.env.PORT || 3000);
var welcomeMessage = "\nWelcome to Probot! Go to " + domain + " to get started.\n";
module.exports = function (app, setup) {
    if (setup === void 0) { setup = new manifest_creation_1.ManifestCreation(); }
    return __awaiter(_this, void 0, void 0, function () {
        var route;
        var _this = this;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    if (!(process.env.NODE_ENV !== 'production' && !(process.env.PROJECT_DOMAIN || process.env.WEBHOOK_PROXY_URL))) return [3 /*break*/, 2];
                    return [4 /*yield*/, setup.createWebhookChannel()];
                case 1:
                    _a.sent();
                    _a.label = 2;
                case 2:
                    route = app.route();
                    app.log.info(welcomeMessage);
                    route.get('/probot', function (req, res) { return __awaiter(_this, void 0, void 0, function () {
                        var protocols, protocol, host, baseUrl, pkg, manifest, createAppUrl;
                        return __generator(this, function (_a) {
                            protocols = req.headers['x-forwarded-proto'] || req.protocol;
                            protocol = typeof protocols === 'string' ? protocols.split(',')[0] : protocols[0];
                            host = req.headers['x-forwarded-host'] || req.get('host');
                            baseUrl = protocol + "://" + host;
                            pkg = setup.pkg;
                            manifest = setup.getManifest(pkg, baseUrl);
                            createAppUrl = setup.createAppUrl;
                            // Pass the manifest to be POST'd
                            res.render('setup.hbs', { pkg: pkg, createAppUrl: createAppUrl, manifest: manifest });
                            return [2 /*return*/];
                        });
                    }); });
                    route.get('/probot/setup', function (req, res) { return __awaiter(_this, void 0, void 0, function () {
                        var code, response;
                        return __generator(this, function (_a) {
                            switch (_a.label) {
                                case 0:
                                    code = req.query.code;
                                    return [4 /*yield*/, setup.createAppFromCode(code)
                                        // If using glitch, restart the app
                                    ];
                                case 1:
                                    response = _a.sent();
                                    // If using glitch, restart the app
                                    if (process.env.PROJECT_DOMAIN) {
                                        child_process_1.exec('refresh', function (err, stdout, stderr) {
                                            if (err) {
                                                app.log.error(err, stderr);
                                            }
                                        });
                                    }
                                    res.redirect(response + "/installations/new");
                                    return [2 /*return*/];
                            }
                        });
                    }); });
                    route.get('/probot/success', function (req, res) { return __awaiter(_this, void 0, void 0, function () {
                        return __generator(this, function (_a) {
                            res.render('success.hbs');
                            return [2 /*return*/];
                        });
                    }); });
                    route.get('/', function (req, res, next) { return res.redirect('/probot'); });
                    return [2 /*return*/];
            }
        });
    });
};
//# sourceMappingURL=setup.js.map