"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var _this = this;
module.exports = function (app) { return __awaiter(_this, void 0, void 0, function () {
    function refresh() {
        return __awaiter(this, void 0, void 0, function () {
            var installations, _a;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0: return [4 /*yield*/, getInstallations()];
                    case 1:
                        installations = _b.sent();
                        stats.installations = installations.length;
                        _a = stats;
                        return [4 /*yield*/, popularInstallations(installations)];
                    case 2:
                        _a.popular = _b.sent();
                        return [2 /*return*/];
                }
            });
        });
    }
    function getInstallations() {
        return __awaiter(this, void 0, void 0, function () {
            var github;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, app.auth()];
                    case 1:
                        github = _a.sent();
                        return [2 /*return*/, github.paginate(github.apps.listInstallations.endpoint.merge({ per_page: 100 }), function (response) {
                                return response.data;
                            })];
                }
            });
        });
    }
    function popularInstallations(installations) {
        return __awaiter(this, void 0, void 0, function () {
            var popular;
            var _this = this;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, Promise.all(installations.map(function (installation) { return __awaiter(_this, void 0, void 0, function () {
                            var account, github, repositories;
                            return __generator(this, function (_a) {
                                switch (_a.label) {
                                    case 0:
                                        account = installation.account;
                                        if (ignoredAccounts.includes(account.login.toLowerCase())) {
                                            account.stars = 0;
                                            app.log.debug({ installation: installation }, 'Installation is ignored');
                                            return [2 /*return*/, account];
                                        }
                                        return [4 /*yield*/, app.auth(installation.id)];
                                    case 1:
                                        github = _a.sent();
                                        return [4 /*yield*/, github.paginate(github.apps.listRepos.endpoint.merge({ per_page: 100 }), function (response) {
                                                return response.data.repositories.filter(function (repository) { return !repository.private; });
                                            })];
                                    case 2:
                                        repositories = _a.sent();
                                        account.stars = repositories.reduce(function (stars, repository) {
                                            return stars + repository.stargazers_count;
                                        }, 0);
                                        return [2 /*return*/, account];
                                }
                            });
                        }); }))];
                    case 1:
                        popular = _a.sent();
                        popular = popular.filter(function (installation) { return installation.stars > 0; });
                        return [2 /*return*/, popular.sort(function (a, b) { return b.stars - a.stars; }).slice(0, 10)];
                }
            });
        });
    }
    var REFRESH_INTERVAL, stats, initializing, ignoredAccounts;
    var _this = this;
    return __generator(this, function (_a) {
        if (process.env.DISABLE_STATS) {
            return [2 /*return*/];
        }
        REFRESH_INTERVAL = 60 * 60 * 1000;
        stats = { installations: 0, popular: [{}] };
        initializing = refresh();
        // Refresh the stats on an interval
        setInterval(refresh, REFRESH_INTERVAL);
        ignoredAccounts = (process.env.IGNORED_ACCOUNTS || '').toLowerCase().split(',');
        // Setup /probot/stats endpoint to return cached stats
        app.router.get('/probot/stats', function (req, res) { return __awaiter(_this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: 
                    // ensure stats are loaded
                    return [4 /*yield*/, initializing];
                    case 1:
                        // ensure stats are loaded
                        _a.sent();
                        res.json(stats);
                        return [2 /*return*/];
                }
            });
        }); });
        return [2 /*return*/];
    });
}); };
//# sourceMappingURL=stats.js.map